/*
 * generated by Xtext 2.9.1
 */
package org.xtext.example.feature.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.xtext.example.feature.feature.Background;
import org.xtext.example.feature.feature.DocString;
import org.xtext.example.feature.feature.Examples;
import org.xtext.example.feature.feature.Feature;
import org.xtext.example.feature.feature.FeaturePackage;
import org.xtext.example.feature.feature.Scenario;
import org.xtext.example.feature.feature.ScenarioOutline;
import org.xtext.example.feature.feature.Step;
import org.xtext.example.feature.feature.Table;
import org.xtext.example.feature.feature.Tag;
import org.xtext.example.feature.services.FeatureGrammarAccess;

@SuppressWarnings("all")
public class FeatureSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private FeatureGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == FeaturePackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case FeaturePackage.BACKGROUND:
				sequence_Background(context, (Background) semanticObject); 
				return; 
			case FeaturePackage.DOC_STRING:
				sequence_DocString(context, (DocString) semanticObject); 
				return; 
			case FeaturePackage.EXAMPLES:
				sequence_Examples(context, (Examples) semanticObject); 
				return; 
			case FeaturePackage.FEATURE:
				sequence_Feature(context, (Feature) semanticObject); 
				return; 
			case FeaturePackage.SCENARIO:
				sequence_Scenario(context, (Scenario) semanticObject); 
				return; 
			case FeaturePackage.SCENARIO_OUTLINE:
				sequence_ScenarioOutline(context, (ScenarioOutline) semanticObject); 
				return; 
			case FeaturePackage.STEP:
				sequence_Step(context, (Step) semanticObject); 
				return; 
			case FeaturePackage.TABLE:
				sequence_Table(context, (Table) semanticObject); 
				return; 
			case FeaturePackage.TAG:
				sequence_Tag(context, (Tag) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Background returns Background
	 *
	 * Constraint:
	 *     (title=Title? narrative=Narrative? steps+=Step+)
	 */
	protected void sequence_Background(ISerializationContext context, Background semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     DocString returns DocString
	 *
	 * Constraint:
	 *     content=DOC_STRING
	 */
	protected void sequence_DocString(ISerializationContext context, DocString semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, FeaturePackage.Literals.DOC_STRING__CONTENT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, FeaturePackage.Literals.DOC_STRING__CONTENT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getDocStringAccess().getContentDOC_STRINGTerminalRuleCall_0_0(), semanticObject.getContent());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Examples returns Examples
	 *
	 * Constraint:
	 *     (title=Title? narrative=Narrative? table=Table)
	 */
	protected void sequence_Examples(ISerializationContext context, Examples semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Feature returns Feature
	 *
	 * Constraint:
	 *     (tags+=Tag* title=Title narrative=Narrative? background=Background? (scenarios+=Scenario | scenarios+=ScenarioOutline)+)
	 */
	protected void sequence_Feature(ISerializationContext context, Feature semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ScenarioOutline returns ScenarioOutline
	 *
	 * Constraint:
	 *     (tags+=Tag* title=Title narrative=Narrative? steps+=Step+ examples=Examples)
	 */
	protected void sequence_ScenarioOutline(ISerializationContext context, ScenarioOutline semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Scenario returns Scenario
	 *
	 * Constraint:
	 *     (tags+=Tag* title=Title narrative=Narrative? steps+=Step+)
	 */
	protected void sequence_Scenario(ISerializationContext context, Scenario semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Step returns Step
	 *
	 * Constraint:
	 *     (stepKeyword=StepKeyword description=StepDescription tables+=Table* code=DocString? tables+=Table*)
	 */
	protected void sequence_Step(ISerializationContext context, Step semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Table returns Table
	 *
	 * Constraint:
	 *     rows+=TABLE_ROW+
	 */
	protected void sequence_Table(ISerializationContext context, Table semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Tag returns Tag
	 *
	 * Constraint:
	 *     id=TAGNAME
	 */
	protected void sequence_Tag(ISerializationContext context, Tag semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, FeaturePackage.Literals.TAG__ID) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, FeaturePackage.Literals.TAG__ID));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getTagAccess().getIdTAGNAMETerminalRuleCall_0_0(), semanticObject.getId());
		feeder.finish();
	}
	
	
}
